;EBX == Full size of font
;ECX == Size in bytes of each bitmap (glyph)
;ESI == Source (font contents)
;EDI == Destination (VGA plane 2 memory)
;;
align wideword_sz
VGA_FontLoader_80x25x16:
 push wideax
 push widebx
 push widesi
 push widedi
 push widebp
 pushfwide


;;;;INIT: Save VGA Registers
;;;;INIT: Save VGA Registers
;;;;INIT: Save VGA Registers
;;;;INIT: Save VGA Registers
;;;;INIT: Save VGA Registers
;;;;INIT: Save VGA Registers
;;;;INIT: Save VGA Registers
;;;;INIT: Save VGA Registers


 ;Save original values for the VGA registers:
 ;;
  xor widebp,widebp
  xor wideax,wideax


;Graphics Controller Register, Index 5, Graphics Mode (RW; 0x3CE=5; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-1 -- Write Mode
 ;             Select write mode 0 to 3 (0 here)
 ;
 ;        2 -- Reserved, undefined on read
 ;
 ;        3 -- Read Type
 ;
 ;        4 -- Odd/Even
 ;
 ;        5 -- Shift Register
 ;
 ;        6 -- 256 Color Mode
 ;
 ;        7 -- Reserved
 ;;
  mov al,5
  call VGA_read_single_Graphics_Register
  ;shl wideax,0   ;removed
  or  widebp,wideax

;Graphics Controller Register, Index 6, Miscellaneous (RW; 0x3CE=6; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;        0 -- Graphics Mode
 ;             Graphics Mode (1) or Text Mode (0)
 ;
 ;        1 -- Odd/Even
 ;
 ;      2,3 -- Memory Map (3 here)
 ;                    Map 0 -- 0xA0000-0xBFFFF
 ;                    Map 1 -- 0xA0000-0xAFFFF
 ;                    Map 2 -- 0xB0000-0xBFFFF
 ;                    Map 3 -- 0xB8000-0xBFFFF
 ;
 ;      4-7 -- Reserved
 ;;
  mov al,6
  call VGA_read_single_Graphics_Register
  shl wideax,8
  or  widebp,wideax

;Sequencer Register, Index 2, Map Mask Register (RW; 0x3C4=2; 0x3C5):
;;
 ;
 ;  Bits:
 ;    0-3 -- Map mask
 ;           Enable (1) or disable writes (0) to the corresponding map, 0-3, with bits 0-3
 ;
 ;    All other bits are reserved.
 ;;
  mov al,2
  call VGA_read_single_Sequencer_Register
  shl wideax,16
  or  widebp,wideax

;Sequencer Register, Index 4, Memory Mode Register (RW; 0x3C4=4; 0x3C5):
;;
 ;
 ;  Bits:
 ;      0 -- Reserved
 ;
 ;      1 -- Extended Memory (1)
 ;           0 -- No extended memory present (less than 64K)
 ;           1 -- Extended memory present (more than 64K; use 256K;
 ;                also enables the Character Map Select feature)
 ;
 ;      2 -- Odd/Even (1)
 ;           0 -- Direct even addresses to maps 0 and 2 and odd addresses
 ;                to maps 1 and 3.
 ;           1 -- If bit 3 is 0: make the CPU access data sequentially
 ;                within a bit map.
 ;
 ;      3 -- Chain-4 (1)
 ;           0 -- If bit 2 is 1, make the CPU access data sequentially within
 ;                a bit map by the Map Mask Register.
 ;           1 -- Make the two lower address bits to select the map that will
 ;                be accessed.
 ;
 ;
 ;    4-7 -- Reserved
 ;;
  mov al,4
  call VGA_read_single_Sequencer_Register
  shl wideax,24
  or  widebp,wideax

  push widebp


;;;;END:  Save VGA Registers
;;;;END:  Save VGA Registers
;;;;END:  Save VGA Registers
;;;;END:  Save VGA Registers
;;;;END:  Save VGA Registers
;;;;END:  Save VGA Registers
;;;;END:  Save VGA Registers
;;;;END:  Save VGA Registers




 ;;;INIT: Reconfigure VGA registers
 ;;;INIT: Reconfigure VGA registers
 ;;;INIT: Reconfigure VGA registers
 ;;;INIT: Reconfigure VGA registers
 ;;;INIT: Reconfigure VGA registers



;Graphics Controller Register, Index 5, Graphics Mode (RW; 0x3CE=5; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-1 -- Write Mode: 00
 ;             Select write mode 0 to 3 (mode 0 here)
 ;
 ;        2 -- Reserved, undefined on read
 ;
 ;        3 -- Read Type: 0
 ;
 ;        4 -- Odd/Even: 0
 ;
 ;        5 -- Shift Register: 0
 ;
 ;        6 -- 256 Color Mode: 0
 ;
 ;        7 -- Reserved
 ;;
   mov ax,5
   call VGA_write_single_Graphics_Register



;Graphics Controller Register, Index 6, Miscellaneous (RW; 0x3CE=6; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;        0 -- Graphics Mode
 ;             Text Mode (0) or Graphics Mode (1)
 ;
 ;        1 -- Odd/Even: (0: Standard VGA addressing)
 ;
 ;      2,3 -- Memory Map (01 here: Map 1 -- 0xA0000-0xAFFFF -- 64 Kilobytes at base address 0xA0000)
 ;
 ;      4-7 -- Reserved
 ;;
   mov ax,0406h
   call VGA_write_single_Graphics_Register

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;Sequencer Register, Index 2, Map Mask Register (RW; 0x3C4=2; 0x3C5):
;;
 ;
 ;  Bits:
 ;    0-3 -- Map mask (Here: Enable Map 2 only -- hardware text font plane)
 ;           Enable (1) or disable writes (0) to the corresponding map, 0-3, with bits 0-3
 ;
 ;    All other bits are reserved.
 ;;
   mov ax,0402h
   call VGA_write_single_Sequencer_Register




;Sequencer Register, Index 4, Memory Mode Register (RW; 0x3C4=4; 0x3C5):
;;
 ;
 ;  Bits:
 ;      0 -- Reserved
 ;
 ;      1 -- Extended Memory (1)
 ;           0 -- No extended memory present (less than 64K)
 ;           1 -- Extended memory present (more than 64K; use 256K;
 ;                also enables the Character Map Select feature)
 ;
 ;      2 -- Odd/Even (1)
 ;           0 -- Direct even addresses to maps 0 and 2 and odd addresses
 ;                to maps 1 and 3.
 ;           1 -- If bit 3 is 0: make the CPU access data sequentially
 ;                within a bit map.
 ;
 ;      3 -- Chain-4 (0)
 ;           0 -- If bit 2 is 1, make the CPU access data sequentially within
 ;                a bit map by the Map Mask Register.
 ;           1 -- Make the two lower address bits to select the map that will
 ;                be accessed.
 ;
 ;
 ;    4-7 -- Reserved
 ;;
   mov ax,0604h
   call VGA_write_single_Sequencer_Register


 ;;;END:  Reconfigure VGA registers
 ;;;END:  Reconfigure VGA registers
 ;;;END:  Reconfigure VGA registers
 ;;;END:  Reconfigure VGA registers
 ;;;END:  Reconfigure VGA registers




;Calculate the number of bytes to skip here
;from the possible total of 32 bytes per glyph:
;;
 mov widebp,32      ;The size of 32 is set by hardware at least for mode 80x25x16 colors
 sub widebp,widecx     ;$WIDEBP=32-$WIDECX;



  .copyFont:
   push widecx


    ;Copy the character's glyph in sequential memory:
    ;;
      align wideword_sz
      rep movsb    ;Es preferible copiar la fuente
                   ;byte por byte, para soportar cualquier
                   ;tamao arbitrario entre 1 y 32,
                   ;mientras no tengamos un cdigo
                   ;ms inteligente y ligeramente
                   ;ms trabajoso que acelere el
                   ;proceso.


   pop widecx

   add widedi,widebp   ;Skip bytes with no content and absent in the font's binary image

  sub widebx,widebp
  jg .copyFont;







;;;;INIT: Restore VGA Registers
;;;;INIT: Restore VGA Registers
;;;;INIT: Restore VGA Registers
;;;;INIT: Restore VGA Registers
;;;;INIT: Restore VGA Registers
;;;;INIT: Restore VGA Registers
;;;;INIT: Restore VGA Registers
;;;;INIT: Restore VGA Registers


 ;Restore original values of VGA registers:
 ;;
  pop widebx


;Graphics Controller Register, Index 5, Graphics Mode (RW; 0x3CE=5; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-1 -- Write Mode
 ;             Select write mode 0 to 3 (0 here)
 ;
 ;        2 -- Reserved, undefined on read
 ;
 ;        3 -- Read Type
 ;
 ;        4 -- Odd/Even
 ;
 ;        5 -- Shift Register
 ;
 ;        6 -- 256 Color Mode
 ;
 ;        7 -- Reserved
 ;;
  mov al,5
  mov ah,bl
  call VGA_write_single_Graphics_Register


;Graphics Controller Register, Index 6, Miscellaneous (RW; 0x3CE=6; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;        0 -- Graphics Mode
 ;             Graphics Mode (1) or Text Mode (0)
 ;
 ;        1 -- Odd/Even
 ;
 ;      2,3 -- Memory Map (3 here)
 ;                    Map 0 -- 0xA0000-0xBFFFF
 ;                    Map 1 -- 0xA0000-0xAFFFF
 ;                    Map 2 -- 0xB0000-0xBFFFF
 ;                    Map 3 -- 0xB8000-0xBFFFF
 ;
 ;      4-7 -- Reserved
 ;;
  mov al,6
  ror widebx,8  ;ebx in case of error
  mov ah,bl
  call VGA_write_single_Graphics_Register


;Sequencer Register, Index 2, Map Mask Register (RW; 0x3C4=2; 0x3C5):
;;
 ;
 ;  Bits:
 ;    0-3 -- Map mask
 ;           Enable (1) or disable writes (0) to the corresponding map, 0-3, with bits 0-3
 ;
 ;    All other bits are reserved.
 ;;
  mov al,2
  ror widebx,8   ;in csae of
  mov ah,bl
  call VGA_write_single_Sequencer_Register


;Sequencer Register, Index 4, Memory Mode Register (RW; 0x3C4=4; 0x3C5):
;;
 ;
 ;  Bits:
 ;      0 -- Reserved
 ;
 ;      1 -- Extended Memory (1)
 ;           0 -- No extended memory present (less than 64K)
 ;           1 -- Extended memory present (more than 64K; use 256K;
 ;                also enables the Character Map Select feature)
 ;
 ;      2 -- Odd/Even (1)
 ;           0 -- Direct even addresses to maps 0 and 2 and odd addresses
 ;                to maps 1 and 3.
 ;           1 -- If bit 3 is 0: make the CPU access data sequentially
 ;                within a bit map.
 ;
 ;      3 -- Chain-4 (1)
 ;           0 -- If bit 2 is 1, make the CPU access data sequentially within
 ;                a bit map by the Map Mask Register.
 ;           1 -- Make the two lower address bits to select the map that will
 ;                be accessed.
 ;
 ;
 ;    4-7 -- Reserved
 ;;
  mov al,4
  ror widebx,8
  mov ah,bl
  call VGA_write_single_Sequencer_Register


;;;;END:  Restore VGA Registers
;;;;END:  Restore VGA Registers
;;;;END:  Restore VGA Registers
;;;;END:  Restore VGA Registers
;;;;END:  Restore VGA Registers
;;;;END:  Restore VGA Registers
;;;;END:  Restore VGA Registers
;;;;END:  Restore VGA Registers





 popfwide
 pop widebp
 pop widedi
 pop widesi
 pop widebx
 pop wideax
retwide
db 'aaaa'




;EOF