;ESI == Desired Palette Structure (RGB triplets)
;ECX == Number of bytes in the Palette
;;
VGA_setPalette:
 push wideax
 push widecx
 push widedx
 pushfwide

    mov dx,0x3C8
    xor eax,eax     ;Start of Palette (color 0 to 255)
    out dx,al

    mov dx,0x3C9
    align wideword_sz
    rep outsb

 popfwide
 pop widedx
 pop widecx
 pop wideax
retwide







;AL == Initial color index (0-255)
;ESI == Desired Palette Structure (RGB triplets)
;ECX == Number of bytes in the Palette
;;
VGA_setPalette_partial:
 push wideax
 push widecx
 push widedx
 pushfwide

    mov dx,0x3C8
    ;xor eax,eax     ;Start of Palette (color 0 to 255)
    out dx,al

    mov dx,0x3C9
    align wideword_sz
    rep outsb

 popfwide
 pop widedx
 pop widecx
 pop wideax
retwide




























;EDI == Desired Palette Structure (RGB triplets)
;ECX == Number of bytes to read from the Palette
;;
VGA_getPalette:
 push wideax
 push widecx
 push widedx
 pushfwide

    mov dx,0x3C7
    xor eax,eax     ;Start of Palette (color 0 to 255)
    out dx,al

    mov dx,0x3C9
    align wideword_sz
    rep insb


 popfwide
 pop widedx
 pop widecx
 pop wideax
retwide





;AL == Intial color 0-255
;EDI == Desired Palette Structure (RGB triplets)
;ECX == Number of bytes to read from the Palette
;;
VGA_getPalette_partial:
 push wideax
 push widecx
 push widedx
 pushfwide

    mov dx,0x3C7
    ;xor eax,eax     ;Start of Palette (color 0 to 255)
    out dx,al

    mov dx,0x3C9
    align wideword_sz
    rep insb


 popfwide
 pop widedx
 pop widecx
 pop wideax
retwide











;WIDESI == Desired Palette Structure (RGB triplets)
;WIDEAX == Start VGA palette color (0-255)
;WIDECX == Size of palette
;;
VGA_set_BMP_256color_Palette:
 push wideax
 push widecx
 push widedx
 pushfwide

 ;We need to pass 4 bytes as a minimum,
 ;or end immediately:
 ;;
  cmp widecx,4
  jb .end



    mov dx,0x3C8
    ;xor eax,eax     ;Start of Palette (color 0 to 255)
    out dx,al

    mov dx,0x3C9



    align wideword_sz
    .loopp:

      lodsd

      rol eax,8  ;Move dummy byte at must significant byte of EAX to AL
      rol eax,8  ;Skip dummy byte for B, and convert 8-bit colors to 6-bit colors
      push wideax
      ror al,2  ;try ror to see if it affects reserved palette color bitrs
      out dx,al  ;B (bits )
      pop wideax
      rol eax,8  ;Skip the B

      push wideax
      ror al,2  ;try ror to see if it affects reserved palette color bitrs
      out dx,al  ;G (bits )
      pop wideax
      rol eax,8  ;Skip the G

      push wideax
      ror al,2  ;try ror to see if it affects reserved palette color bitrs
      out dx,al  ;R (bits )
      pop wideax
      ;rol eax,8  ;Skip the R


    sub widecx,4
    jnz .loopp
;    jc .loopp  ;if results < 0
;    jo .loopp  ;if results < 0



 .end:

 popfwide
 pop widedx
 pop widecx
 pop wideax
retwide











;WIDESI == Desired Palette Structure (RGB triplets)
;WIDEAX == Start VGA palette color (0-255)
;WIDECX == Size of palette
;;
VGA_set_BMP_256color_Palette__GOLD:   ;It gives golden color
 push wideax
; push widebx
 push widecx
 push widedx
 pushfwide

 ;We need to pass 4 bytes as a minimum,
 ;or end immediately:
 ;;
  cmp widecx,4
  jb .end



;    mov widebx,widecx

    mov dx,0x3C8
    ;xor eax,eax     ;Start of Palette (color 0 to 255)
    out dx,al

    mov dx,0x3C9



    align wideword_sz
    .loopp:
;;      mov widecx,3
;      mov widecx,1

;      .loop2:
        ;lodsb
        ;shr al,2   ;Conver 8-bit color to 6-color
        ;outsb

      lodsd
;      ror eax,8+2  ;Skip dummy byte for R, and convert 8-bit colors to 6-bit colors

      ror eax,8  ;Skip dummy byte for R, and convert 8-bit colors to 6-bit colors
      push wideax
      shr al,2  ;try ror to see if it affects reserved palette color bitrs
      out dx,al  ;R (bits 8-15)
      pop wideax

      ror eax,8
      push wideax
      shr al,2  ;try ror to see if it affects reserved palette color bitrs
      out dx,al  ;G (bits 16-23)
      pop wideax

      ror eax,8
      push wideax
      shr al,2  ;try ror to see if it affects reserved palette color bitrs
      out dx,al  ;B (bits 24-31)
      pop wideax


;      dec cl
;      jnz .loop2
;      lodsb      ;Increasea dummy byte for the DWORD palette entries of the BMP format

;    sub widebx,4
    sub widecx,4
    jnz .loopp
;    jc .loopp  ;if results < 0
;    jo .loopp  ;if results < 0



 .end:

 popfwide
 pop widedx
 pop widecx
; pop widebx
 pop wideax
retwide















;EOF