;Inputs:
;      AH == 00100000b -- turn monitor off
;      AH == 11011111b -- turn monitor on
;;
VGA_Sequencer_Monitor_On:
 mov ah,11011111b
 jmp VGA_Sequencer_Monitor_OnOff

VGA_Sequencer_Monitor_Off:
 mov ah,00100000b


VGA_Sequencer_Monitor_OnOff:
push wideax
push widedx
pushfwide

  mov dx,0x3C4       ;Sequencer Index Register
  mov al,01h         ;Clocking Mode Register (Index 01h)
  out dx,al          ;Specify it!

  mov dx,0x3C5       ;Sequencer Data Register
  in al,dx           ;Read it for Clocking Mode Register

  cmp ah,11011111b   ;A. See if it's a turning off request
  jmp .default1      ;Skip code that's only to fix bogus request
   .default0:
    mov ah,11011111b
    jmp .default_monitorOn
  .default1:
  jnz .ah_not_11011111b ;A. If not, see if it's for turning on
  .default_monitorOn:
    and al,ah    ;Disable Monitor Off bit
   jmp .executePortCommand

  .ah_not_11011111b:
  cmp ah,00100000b  ;B. See if it's a turning on request
  jne .default0     ;B. If not, turn on monitor by default
    or al,ah      ;Enable Monitor Off bit

  .ah_not_00100000b:

  .executePortCommand:
  out dx,al          ;Send it!


popfwide
pop widedx
pop wideax
ret




;EOF