;Version 2013-03-10
;;

EGA_Text_80x25x16Gen__MiscOutputReg:
;General Register, Miscellaneous Output (W; 0x3C2):
;;
 ;
 ;  Bits:
 ;      0 -- I/O Address select
 ;           Color Emulation  (1) or Monochrome Emulation   (0)
 ;
 ;      1 -- Enable RAM
 ;           Enable video RAM (1) or Disable address decode (0)
 ;
 ;    2,3 -- Clock Select - ??? - I currently don't know where is the CS2 bit
 ;                                so I don't know what configuration is selected here
 ;           CS2  CS1  CS0  Clock
 ;           ---  ---  ---  -----
 ;            0    0    0   25.175 MHz    ;<--this one!!!!!!!
 ;            0    0    1   28.322 MHz
 ;         -------------------------------Below this line, consider Oak-specific values
 ;            0    1    0   65 MHz (external clock per true VGA standard)
 ;            0    1    1   44.9 MHz (undefined per true VGA standard)
 ;            1    0    0   14.161 MHz (derived from 28.322 MHz)
 ;            1    0    1   18 MHz (derived from 36 MHz)
 ;            1    1    0   40 MHz
 ;            1    1    1   36 MHz
 ;
 ;      4 -- Reserved
 ;            (0)
 ;
 ;      5 -- Page bit for odd/even
 ;           High 64K         (1) or Low 64K                (0) page of memory
 ;
 ;      6 -- Horizontal Sync Polarity
 ;           Negative         (1) or Posite Vertic. Retrace (0)
 ;
 ;      7 -- Vertical Sync Polarity
 ;           Positive         (0) or Negative Vert. Retrace (0)
 ;
 ;      Bits 7-6
 ;      --------
 ;            00 -- reserved
 ;            01 -- 400 lines     ;<-- This one!
 ;            10 -- 350 lines
 ;            11 -- 480 lines
 ;
 ;
 ;
 ;
 ;
 ;;
;  db 01100111b       ;0x67
db 0x67









EGA_Text_80x25x16Gen__FeatureControlReg:
;General Register, Feature Control (RW; 0x3DA color; 0x3BA mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      3 -- Vertical Sync Select
 ;           Normal (0) or Logical OR of Vertical Sync End/Vertical Display Enable (1)
 ;
 ;      All other bits are Reserved
 ;
 ;;
;  db 00000000b       ;0x00
db 4h



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;





EGA_Text_80x25x16SequencerRegs:
;Sequencer Register, Index 0, Reset Register (RW; 0x3C4=0; 0x3C5):
;;
 ;
 ;  Bits:
 ;      0 -- Asynchronous Reset
 ;           Operating  (1) or Reset   (0)
 ;
 ;      1 -- Synchronous Reset
 ;           Operating  (1) or Reset   (0)
 ;
 ;      All other bits are reserved
 ;;
  db 00000011b       ;0x03










;Sequencer Register, Index 1, Clocking Mode Register (RW; 0x3C4=1; 0x3C5):
;;
 ;
 ;  Bits:
 ;      0 -- 8/9 dot clocks
 ;           Eight dots (1) or Nine Clocks (0)
 ;
 ;      1 -- Reserved
 ;
 ;      2 -- Shift Load
 ;           If bit 4 is 0:
 ;           Reload serializers each char clock (0) or on every other (1)
 ;
 ;      3 -- Dot clock
 ;           Normal clock (0) or divide clock by 2 (1)
 ;
 ;      4 -- Shift 4
 ;           Reload serializers each char clock (0) or on each fourth (1)
 ;
 ;      5 -- Screen off
 ;           Video screen off and max mem bandwidth to CPU (1) or Normal operation (0)
 ;
 ;    6-7 -- Reserved
 ;;
  db 00000000b       ;0x00










;Sequencer Register, Index 2, Map Mask Register (RW; 0x3C4=2; 0x3C5):
;;
 ;
 ;  Bits:
 ;    0-3 -- Map mask
 ;           Enable (1) or disable writes (0) to the corresponding map, 0-3, with bits 0-3
 ;
 ;    All other bits are reserved.
 ;;
  db 00000011b       ;0x03










;Sequencer Register, Index 3, Character Map Select Register (RW; 0x3C4=3; 0x3C5):
;;
 ;
 ;  Bits:
 ;    4,1,0 -- Character Map Select B
 ;             000
 ;             1st 8K of Map 2
 ;
 ;    5,3,0 -- Character Map Select A
 ;             000
 ;             1st 8K of Map 2
 ;             NOTE: The value of Character Map Select A == Character Map Select B,
 ;                   so we will ignore Character Map Select A and use
 ;                   Character Map Select B configuration.
 ;
 ;    All other bits are reserved.
 ;;
  db 00000000b       ;0x00










;Sequencer Register, Index 4, Memory Mode Register (RW; 0x3C4=4; 0x3C5):
;;
 ;
 ;  Bits:
 ;      0 -- Reserved
 ;
 ;      1 -- Extended Memory (1)
 ;           0 -- No extended memory present (less than 64K)
 ;           1 -- Extended memory present (more than 64K; use 256K;
 ;                also enables the Character Map Select feature)
 ;
 ;      2 -- Odd/Even (1)
 ;           0 -- Direct even addresses to maps 0 and 2 and odd addresses
 ;                to maps 1 and 3.
 ;           1 -- If bit 3 is 0: make the CPU access data sequentially
 ;                within a bit map.
 ;
 ;      3 -- Chain-4 (1)
 ;           0 -- If bit 2 is 1, make the CPU access data sequentially within
 ;                a bit map by the Map Mask Register.
 ;           1 -- Make the two lower address bits to select the map that will
 ;                be accessed.
 ;
 ;
 ;    4-7 -- Reserved
 ;;
;  db 00000010b       ;0x02
;db 7   ;in text mode causes planes to be badly selected and all
        ;letters have a different color.
db 2



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;










EGA_Text_80x25x16CRTCRegs:
;CRTC Controller, Index 0, Horizontal Total (RW; 0x3D4=0 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- Number of horizontal characters MINUS 5
 ;;
;  db 95              ;0x5F
db 0x5F


;from 0x5F to 61h??????






;CRTC Controller, Index 1, Horizontal Display-Enable End (RW; 0x3D4=1 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- Number of total displayed characters MINUS 1
 ;;
;  db 79              ;0x4F
db 0x4F

;from 4fh???? to 50h?????







;CRTC Controller, Index 2, Start Horizontal Blanking Register (RW; 0x3D4=2 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- Number of total displayed characters MINUS 1
 ;;
;  db 01010000b       ;0x50
db 0x50









;CRTC Controller, Index 3, End Horizontal Blanking Register (RW; 0x3D4=3 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-4 -- End Horizontal Blanking (2 here)
 ;
 ;      5,6 -- Display Enable Skew Control (0 here)
 ;
 ;        7 -- Test bit; must be 1
 ;;
;  db 10000010b       ;0x82
db 0x82









;CRTC Controller, Index 4, Start Horizontal Retrace Pulse (RW; 0x3D4=4 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- Start Horizontal Retrace Pulse (84 here)
 ;;
;  db 01010101b       ;0x55
;db 0x55
db 0x54
;From 47h to 5h???







;CRTC Controller, Index 5, End Horizontal Retrace Pulse (RW; 0x3D4=5 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-4 -- End Horizontal Retrace
 ;      5-6 -- Horizontal Retrace Delay
 ;        7 -- End Horizontal Blanking, Bit 5
 ;;
;  db 10000001b       ;0x81
;db 0x81
db 0x80








;CRTC Controller, Index 6, Vertical Total (RW; 0x3D4=6 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- 8 lower bits of number of horizontal raster scans MINUS 2
 ;;
;  db 10111111b       ;0xBF
db 0xBF









;CRTC Controller, Index 7, Overflow (RW; 0x3D4=7 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0 -- bit 8 of vertical total, reg idx 0x06
 ;      1 -- bit 8 of vertical total, reg idx 0x12
 ;      2 -- bit 8 of vertical total, reg idx 0x10
 ;      3 -- bit 8 of vertical total, reg idx 0x15
 ;      4 -- bit 8 of vertical total, reg idx 0x18
 ;      5 -- bit 9 of vertical total, reg idx 0x06
 ;      6 -- bit 9 of vertical total, reg idx 0x12
 ;      7 -- bit 9 of vertical total, reg idx 0x10
 ;;
;  db 00011111b       ;0x1F
db 0x1F









;CRTC Controller, Index 8, Preset Row Scan (RW; 0x3D4=8 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-4 -- preset row scan
 ;      5-6 -- byte panning control
 ;      7 -- reserved
 ;;
  db 00000000b       ;0x00










;CRTC Controller, Index 9, Maximum Scan Line (RW; 0x3D4=9 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-4 -- maximum scan line
 ;        5 -- start vertical blank
 ;        6 -- line compare
 ;        7 -- 200 to 400 line conversion
 ;;
;  db 01001111b       ;0x4F
;db 0xC7
db 0x4F

;NOTE: This can duplicate the size of the font,
;      and the maximum scan line field could be
;      useful for instance for 8x8 modes and to be
;      able to use up to 32-line-height fonts, thus
;      the bit range 0-4, for 00000b (0) to 11111b (31).






;CRTC Controller, Index 10, Cursor Start (RW; 0x3D4=0x0A color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-4 -- cursor start
 ;        5 -- cursor off
 ;      6-7 -- reserved
 ;;
;  db 00001110b       ;0x0E
;db 6
;db 0xD
db 0xE







;CRTC Controller, Index 11, Cursor End (RW; 0x3D4=0x0B color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-4 -- cursor end
 ;      5-6 -- cursor skew
 ;        7 -- reserved
 ;;
;  db 00001111b       ;0x0F
;db 7
;db 0xE
db 0xF








;CRTC Controller, Index 12, Start Address High (RW; 0x3D4=0x0C color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- start address high
 ;;
  db 00000000b       ;0x00







;seems to affect horizontally, but has to do with vertical retrace



;CRTC Controller, Index 13, Start Address Low (RW; 0x3D4=0x0D color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- start address low
 ;;
  db 00000000b       ;0x00


;seems to affect horizontally, but has to do with vertical retrace







;CRTC Controller, Index 14, Cursor Location High (RW; 0x3D4=0x0E color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- cursor high
 ;;
  db 00000000b       ;0x00










;CRTC Controller, Index 15, Cursor Location Low (RW; 0x3D4=0x0F color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- cursor low
 ;;
  db 00000000b       ;0x00









;CRTC Controller, Index 16, Vertical Retrace Start (W; 0x3D4=0x10 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 - lower 8 bits of vertical retrace pulse start position
 ;;
;  db 156             ;0x9C
db 0x9C


;From???? 0x90?? to 0xBF?






;CRTC Controller, Index 17, Vertical Retrace End (W; 0x3D4=0x11 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-3 -- vertical retrace end
 ;        4 -- clear vertical interrupt
 ;        5 -- enable vertical interrupt
 ;        6 -- select 5 refresh cycles
 ;        7 -- protect registers 0 to 7: True (1) or False (0)
 ;;
;  db 00001110b       ;0x0E
db 0x0E


;affects visually more the upper line of the screen (bits 0-3)






;CRTC Controller, Index 18, Vertical Display Enable End (RW; 0x3D4=0x12 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- vertical display enable end
 ;;
;  db 143             ;0x8F
db 0x8F

;from 8fh?? or even 0, to ffh (c0h is funny) -- see below.

;lower 8 bits of 10 bits that indicate the number of lines to show
;vertically before showing nothing.
;Bits 8 and 9 are in the overflow register bits 1 and 6 respectively,
;so here we have an overal value of 399 (as in 400 for 640x400 mode :) ).
;
;FROM HERE WE ARE FIRST STARTING TO UNDERSTAND HOW TO CONTROL
;SOME ASPECTS OF RESOLUTION AND OF SHOWING IT.
;
;And if we try to show more lines than existing, for instance
;FFh here for 80x25 text mode, the screen could scroll with a
;bad aspect.....







;CRTC Controller, Index 19, Offset (RW; 0x3D4=0x13 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- offset
 ;;
;  db 40              ;0x28
db 0x28









;CRTC Controller, Index 20, Underline Location (RW; 0x3D4=0x14 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-4 -- underline location
 ;        5 -- count by 4
 ;        6 -- double word mode
 ;        7 -- reserved
 ;;
;  db 00011111b       ;0x1F
db 0x1F


;NOTE: bits 0-4 could be associated with the maximum scan line field
;      in other register (I changed this alone, to 0, and didn't seem
;      to have any visual effect).

;      Bit 5 used alone (count by 4) is very interesting in text mode.
;      When enabled, it causes every character cell to be repeated
;      4 times (except the first character leftmost, repeated 3 times).
;      It also repeats the cursor, in 3 or 4 consecutive character cells.
;
;      Bit 6, double word mode, seems to use 4 bytes for a single
;      character in screen, and it also alters its display, in text mode,
;      to an almost unintelligible form, and also seems to duplicate
;      some content in the screen in 2 halves.




;CRTC Controller, Index 21, Start Vertical Blanking (RW; 0x3D4=0x15 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- start vertical blank -- lower 8 bits of 10-bit register
 ;;
;  db 150             ;0x96
db 0x96


;NOTE: This field accepted 0 without trouble, without
;taking bits 8 and 9 in the overflow reg.
;
;Just caused a hole in some text lines past half the screen.






;CRTC Controller, Index 22, End Vertical Blanking (RW; 0x3D4=0x16 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- end vertical blank
 ;;
;  db 185             ;0xB9
db 0xB9









;CRTC Controller, Index 23, CRTC Mode Control (RW; 0x3D4=0x17 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0 -- compatibility mode support
 ;      1 -- select row scan counter
 ;      2 -- horizontal retrace select
 ;      3 -- count by two
 ;      4 -- reserved
 ;      5 -- address wrap
 ;      6 -- word mode (0) or byte mode (1)
 ;      7 -- hardware reset
 ;;
;  db 10100011b       ;0xA3
db 0xA3

;This is another interesting register,
;specially bit 6 and bit 3, the most visual ones.

;The count by 2 field is like the count by 4, only that
;a character is shown 2 times consecutively instead of 4.
;The leftmost screen characters are only shown once.

;NOTE: This count by 2 bit has precedence over the count by 4
;      bit in other register. If count by 2 is enabled,
;      then count by 4 has no visual effect.






;CRTC Controller, Index 24, Line Compare (RW; 0x3D4=0x18 color; 0x3B4 mono; 0x3D5 color; 0x3B5 mono):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- lower 8 bits of compare target.
 ;             Bit 8 is in Overflow register index 7.
 ;             Bit 9 is in Maximum Scan Line register index 9. 
 ;;
  db 11111111b       ;0xFF


;NOTE: Changing this very register to 0 didn't seem to have any effect.


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;





EGA_Text_80x25x16GraphicsRegs:
;Graphics Controller Register, Index 0, Set/Reset (RW; 0x3CE=0; 0x3CF):
;;
 ;
 ;  Bits:
 ;      0-3 -- Set/Reset
 ;
 ;      All other bits are reserved. Set to 0; undefined on read.
 ;;
  db 00000000b       ;0x00










;Graphics Controller Register, Index 1, Enable Set/Reset (RW; 0x3CE=1; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-3 -- Enable Set/Reset
 ;             1 -- If write mode is 0, and the bit for the map is 1 here,
 ;                  write memory address with the value of the Set/Reset register.
 ;
 ;             0 -- If write mode is 0, and the bit for the map is 0 here,
 ;                  write memory address with the value of system CPU.
 ;
 ;      All other bits are reserved. Set to 0; undefined on read.
 ;;
  db 00000000b       ;0x00










;Graphics Controller Register, Index 2, Color Compare (RW; 0x3CE=2; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-3 -- Color compare
 ;             Color Compare Map n, where n is the bit position
 ;
 ;      All other bits are reserved. Set to 0; undefined on read.
 ;;
  db 00000000b       ;0x00










;Graphics Controller Register, Index 3, Data Rotate (RW; 0x3CE=3; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-2 -- Data rotate
 ;             Number of bits to right-rotate CPU data (0 here)
 ;
 ;      3,4 -- Function select
 ;             00 -- unmodified   <-- this one!!!!!!
 ;             01 -- AND data with latch
 ;             10 -- OR data with latch
 ;             11 -- XOR data with latch
 ;
 ;      All other bits are reserved. Set to 0; undefined on read.
 ;;
  db 00000000b       ;0x0










;Graphics Controller Register, Index 4, Read Map Select (RW; 0x3CE=4; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-1 -- Read Map Select
 ;             Select maps 0 to 3 for system read operations (map 0 here)
 ;
 ;
 ;      All other bits are reserved. Set to 0; undefined on read.
 ;;
  db 00000000b       ;0x00










;Graphics Controller Register, Index 5, Graphics Mode (RW; 0x3CE=5; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-1 -- Write Mode
 ;             Select write mode 0 to 3 (0 here)
 ;
 ;        2 -- Reserved, undefined on read
 ;
 ;        3 -- Read Type
 ;
 ;        4 -- Odd/Even
 ;
 ;        5 -- Shift Register
 ;
 ;        6 -- 256 Color Mode
 ;
 ;        7 -- Reserved
 ;;
;  db 00010000b       ;0x10
db 0x10










;Graphics Controller Register, Index 6, Miscellaneous (RW; 0x3CE=6; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;        0 -- Graphics Mode
 ;             Graphics Mode (1) or Text Mode (0)
 ;
 ;        1 -- Odd/Even
 ;
 ;      2,3 -- Memory Map (3 here)
 ;                    Map 0 -- 0xA0000-0xBFFFF
 ;                    Map 1 -- 0xA0000-0xAFFFF
 ;                    Map 2 -- 0xB0000-0xBFFFF
 ;                    Map 3 -- 0xB8000-0xBFFFF
 ;
 ;      4-7 -- Reserved
 ;;
;  db 00001110b       ;0x0E
db 0x0E









;Graphics Controller Register, Index 7, Color Don't Care (RW; 0x3CE=7; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-3 -- For each bit, if 0, don't participate in color
 ;             compare cycle; if 1 participate in it for that map.
 ;;
;  db 00000000b       ;0x00


db 0x00







;Graphics Controller Register, Index 8, Bit Mask (RW; 0x3CE=8; 0x3CF):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- Bit mask
 ;;
;  db 11111111b       ;0xFF

db 0xFF


;DONE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;










EGA_Text_80x25x16AttributeRegs:
;Attribute Controller Register, Index 0, Palette 0 (RW; 0x3C0=0; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 0               ;0x00










;Attribute Controller Register, Index 1, Palette 1 (RW; 0x3C0=1; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 1               ;0x01










;Attribute Controller Register, Index 2, Palette 2 (RW; 0x3C0=2; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 2               ;0x02










;Attribute Controller Register, Index 3, Palette 3 (RW; 0x3C0=3; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 3               ;0x03










;Attribute Controller Register, Index 4, Palette 4 (RW; 0x3C0=4; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 4               ;0x04










;Attribute Controller Register, Index 5, Palette 5 (RW; 0x3C0=5; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 5               ;0x05










;Attribute Controller Register, Index 6, Palette 6 (RW; 0x3C0=6; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 20              ;0x14










;Attribute Controller Register, Index 7, Palette 7 (RW; 0x3C0=7; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 7               ;0x07










;Attribute Controller Register, Index 8, Palette 8 (RW; 0x3C0=8; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 56              ;0x38










;Attribute Controller Register, Index 9, Palette 9 (RW; 0x3C0=9; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 57              ;0x39










;Attribute Controller Register, Index 10, Palette 10 (RW; 0x3C0=0x0A; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 58              ;0x3A










;Attribute Controller Register, Index 11, Palette 11 (RW; 0x3C0=0x0B; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 59              ;0x3B










;Attribute Controller Register, Index 12, Palette 12 (RW; 0x3C0=0x0C; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 60              ;0x3C










;Attribute Controller Register, Index 13, Palette 13 (RW; 0x3C0=0x0D; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 61              ;0x3D










;Attribute Controller Register, Index 14, Palette 14 (RW; 0x3C0=0x0E; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 62              ;0x3E










;Attribute Controller Register, Index 15, Palette 15 (RW; 0x3C0=0x0F; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-5 -- 0 to 63 color value
 ;
 ;      All other bits are reserved
 ;;
  db 63              ;0x3F










;Attribute Controller, Index 16, Attribute Mode Control (RW; 0x3C0=0x10; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0 -- graphics/alphanumeric
 ;      1 -- mono emulation
 ;      2 -- enable line graphics character codes
 ;      3 -- enable blink (1)/select background intensity (0)
 ;      4 -- reserved
 ;      5 -- PEL panning compatibility
 ;      6 -- PEL width
 ;      7 -- P5, P4 select
 ;
 ;;
  db 00001100b       ;0x0C










;Attribute Controller, Index 17, Overscan Color (RW; 0x3C0=0x11; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-7 -- overscan color
 ;
 ;;
  db 00000000b       ;0x00 or black



;If we disable the palette, everything seems to turn into
;the overscan color, if it isn't black.

;IMPORTANT NOTE: The Attribute controller expects
;                to first write the index and then the value
;                or to write those 2 bytes with a word IO instruction.
;                Otherwise, it behaves as a flip-flop.
;
;                Probably, or probably not, the other controllers
;                behave like this, so let's find that out too.





;Attribute Controller, Index 18, Color Plane Enable (RW; 0x3C0=0x12; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-3 -- enable color plane
 ;      4-5 -- video status MUX
 ;      6-7 -- reserved
 ;
 ;;
  db 00001111b       ;0x0F










;Attribute Controller, Index 19, Horizontal PEL Panning (RW; 0x3C0=0x13; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-3 -- horizontal PEL panning
 ;      4-7 -- reserved
 ;
 ;;
;  db 00000100b       ;0x08      <---- very interesting error'
;  db 00001000b       ;0x08
;db 0
db 8



;'If we use a loop to slowly change this value increasingly/decreasingly,
; we can learn something.
;
; The effect of using 4 instead of 8 was that the screen was "wrapped",
; and some pixels at the leftmost of the screen were shown at the rightmost
; of the screen........





;Attribute Controller, Index 20, Color Select (RW; 0x3C0=0x14; write 0x3C0; read 0x3C1):
;;
 ;
 ;
 ;
 ;  Bits:
 ;      0-1 -- SC5,SC4
 ;      2-3 -- SC6,SC7
 ;      4-7 -- Reserved
 ;
 ;;
  db 00000000b       ;0x00
