;pusht macro - 10 bytes -- and non-native instructions

;v2019-05-06 (Mon)
;v2019-04-26 (Fri)
;v2019-04-23 (Tue)

;Using privileged CLI/STI to enable interrupts only when
;needed, and otherwise keep them off for maximum speed
;is something we would like to achieve transparently
;for system code, but not do for application code,
;so we also define privileged instructions like ...WIDE
;instructions that are portable across privilege levels.
;;
 %ifndef _x86_Portable__LEVEL_
  %ixdefine _x86_Portable__LEVEL_ 0  ;0 system, 1 user
 %endif


;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation


;Automatic size selection for data/variables:
;-------------------------------------------------------------------------
;wideword            -- Automatic size selection, 2, 4 or 8 bytes.
;ww                  -- Automatic size selection, define wideword, 2, 4 or 8 bytes.
;pusha_SZ            -- Automatic size selection, wideword_sz*8
;wideword_SZ         -- Automatic size selection, 2, 4 or 8 bytes.
;wideword_SZ_nibbles -- Number of nibbles (4-bit groups) in the native wideword.
;wideword_SZ_BitRotationMultiply -- Number of left-shifts that give the number of bits in a wideword.
; %ixdefine wideword_SZ 2
; %ixdefine wideword_SZ_nibbles 4
; %ixdefine wideword_bits 16
; %ixdefine wideword_bits_BitRotationMultiply 4
; %ixdefine wideword_bits_mask 1111B
; %ixdefine wideword_SZ_BitRotationMultiply 1
; %ixdefine wideword_MSB 1000000000000000b
; %ixdefine wideword_MSN 1111000000000000b
; %ixdefine wideword_LSN 0000000000001111b




;Automatic size selection for any on-stack call return addresses:
;-------------------------------------------------------------------------
;_CALL_STACK_ADDR_SZ_ -- 2, 4 or 8 bytes.




;Automatic size selection for CPU registers:
;-------------------------------------------------------------------------
;wideax -- 2, 4 or 8 bytes.
;widebx -- 2, 4 or 8 bytes.
;widecx -- 2, 4 or 8 bytes.
;widedx -- 2, 4 or 8 bytes.
;widesi -- 2, 4 or 8 bytes.
;widedi -- 2, 4 or 8 bytes.
;widesp -- 2, 4 or 8 bytes.
;widebp -- 2, 4 or 8 bytes.




;Automatic size selection for "Address" and "Operand" prefixes:
;-------------------------------------------------------------------------
;awide -- a16, a32 or nothing.
;owide -- a16, a32 or nothing.




;Automatic size selection for CPU instructions:
;-------------------------------------------------------------------------
;cmpswide -- 2, 4 or 8 bytes.
;lodswide -- 2, 4 or 8 bytes.
;stoswide -- 2, 4 or 8 bytes.
;movswide -- 2, 4 or 8 bytes.
;inswide  -- 2 or 4 bytes.
;outswide -- 2 or 4 bytes.
;retwide  -- 2, 4 or 8 byte POPs for return addresses.
;End_retwide -- 2, 4 or 8 byte POPs for return addresses (marks end of routine for documentation).
;iretwide -- 2, 4 or 8 byte POPs for return addresses.
;End_iretwide -- 2, 4 or 8 byte POPs for return addresses (marks end of routine for documentation).



;Automatic variable or register selection for 64-bit CPU r8-r9 registers:
;-------------------------------------------------------------------------
;_r8  -- 2, 4 or 8 bytes.
;_r9  -- 2, 4 or 8 bytes.
;_r10 -- 2, 4 or 8 bytes.
;_r11 -- 2, 4 or 8 bytes.
;_r12 -- 2, 4 or 8 bytes.
;_r13 -- 2, 4 or 8 bytes.
;_r14 -- 2, 4 or 8 bytes.
;_r15 -- 2, 4 or 8 bytes.




;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation

;Common units/sizes
;;
 GB equ 1048576*1048576
 MB equ 1048576



;The reason why we don't use numbers like 8086 for 16-bit code
;and 386 for 32-bit code is that this source file is size-oriented
;and we want to indicate the actual machine word size, not just
;the base CPU.
;
;Indicating the CPU as a number might work and be better when we are
;dealing with CPU-oriented code. The fact of naming the CPUs with numbers
;was a very optimizing thinking from people at Intel, so CPUs can be
;directly identified and named in the CPU instructions themselves
;and in software by defining pure numbers.
;
;Set the default mode of x86 Portable to work under
;16-bit Unreal Mode (with access to 4 GB of address space):
;;
 %ifndef _x86_Portable__PLATFORMBITS_
  %ixdefine _x86_Portable__PLATFORMBITS_ 1632
 %endif


x86_Portable_START:

;Include a JMP instruction so that we can include this source file
;anywhere in a NASM/YASM assembly source code without causing failures
;due to the embedded data bytes here:
;;
 align 16
 jmp x86_Portable_END
 align 16

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
%if _x86_Portable__PLATFORMBITS_==16     ;16-bit 8086 code

 %ixdefine _CALL_STACK_ADDR_SZ_ 2

 %ixdefine wideword    word
 %ixdefine ww          dw
 %ixdefine wideword_SZ 2
 %ixdefine pusha_SZ    wideword_sz*8
 %ixdefine wideword_SZ_nibbles 4
 %ixdefine wideword_bits 16
 %ixdefine wideword_bits_BitRotationMultiply 4
 %ixdefine wideword_bits_mask 1111B
 %ixdefine wideword_SZ_BitRotationMultiply 1
 %ixdefine wideword_MSB 1000000000000000b
 %ixdefine wideword_MSN 1111000000000000b
 %ixdefine wideword_LSN 0000000000001111b

 %ixdefine wideax    ax
 %ixdefine widecx    cx
 %ixdefine widedx    dx
 %ixdefine widebx    bx
 %ixdefine widesp    sp
 %ixdefine widebp    bp
 %ixdefine widesi    si
 %ixdefine widedi    di

 %ixdefine _r8       word[__r8]
 %ixdefine _r9       word[__r9]
 %ixdefine _r10      word[__r10]
 %ixdefine _r11      word[__r11]
 %ixdefine _r12      word[__r12]
 %ixdefine _r13      word[__r13]
 %ixdefine _r14      word[__r14]
 %ixdefine _r15      word[__r15]

 __r8  dw 0
 __r9  dw 0
 __r10 dw 0
 __r11 dw 0
 __r12 dw 0
 __r13 dw 0
 __r14 dw 0
 __r15 dw 0


 %ixdefine awide
 %ixdefine owide


 %ixdefine pushfwide pushf
 %ixdefine popfwide  popf
 %ixdefine cmpswide  cmpsw
 %ixdefine lodswide  lodsw
 %ixdefine stoswide  stosw
 %ixdefine movswide  movsw
 %ixdefine inswide   insw
 %ixdefine outswide  outsw
 %ixdefine retwide   ret
 %macro End_retwide 0
 ret
 db "End_ret16"
 align wideword_sz,db 'a'
 %endmacro
 %ixdefine iretwide  iret
 %macro End_iretwide 0
 iret
 db "End_iret16"
 align wideword_sz,db 'a'
 %endmacro

 %ixdefine push_wideax push ax
 %ixdefine push_widesi push si

 %ixdefine pop_wideax pop ax
 %ixdefine pop_widesi pop si

 %ixdefine push_es push es
 %ixdefine pop_es pop es

 %macro jmpfar 2
  jmp %1:%2
 %endmacro




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
%elif _x86_Portable__PLATFORMBITS_==1632   ;16-bit Unreal Mode

 %ixdefine _CALL_STACK_ADDR_SZ_ 2

 %ixdefine wideword    dword
 %ixdefine ww          dd
 %ixdefine wideword_SZ 4
 %ixdefine pusha_SZ    wideword_sz*8
 %ixdefine wideword_SZ_nibbles 8
 %ixdefine wideword_bits 32
 %ixdefine wideword_bits_BitRotationMultiply 5
 %ixdefine wideword_bits_mask 11111B
 %ixdefine wideword_SZ_BitRotationMultiply 2
 %ixdefine wideword_MSB 10000000000000000000000000000000b
 %ixdefine wideword_MSN 11110000000000000000000000000000b
 %ixdefine wideword_LSN 00000000000000000000000000001111b

 %ixdefine wideax    eax
 %ixdefine widecx    ecx
 %ixdefine widedx    edx
 %ixdefine widebx    ebx
 %ixdefine widesp    esp
 %ixdefine widebp    ebp
 %ixdefine widesi    esi
 %ixdefine widedi    edi

 %ixdefine _r8       dword[__r8]
 %ixdefine _r9       dword[__r9]
 %ixdefine _r10      dword[__r10]
 %ixdefine _r11      dword[__r11]
 %ixdefine _r12      dword[__r12]
 %ixdefine _r13      dword[__r13]
 %ixdefine _r14      dword[__r14]
 %ixdefine _r15      dword[__r15]

 __r8  dd 0
 __r9  dd 0
 __r10 dd 0
 __r11 dd 0
 __r12 dd 0
 __r13 dd 0
 __r14 dd 0
 __r15 dd 0


 %ixdefine awide     a32
 %ixdefine owide     o32


 %ixdefine pushfwide pushf
 %ixdefine popfwide  popf
 %ixdefine cmpswide  cmpsd
 %ixdefine lodswide  lodsd
 %ixdefine stoswide  stosd
 %ixdefine movswide  movsd
 %ixdefine inswide   insd
 %ixdefine outswide  outsd
 %ixdefine retwide   ret
 %macro End_retwide 0
 ret
 db "End_retwide1632"
 align wideword_sz,db 'a'
 %endmacro
 %ixdefine iretwide  iret
 %ixdefine End_iretwide  iret
 %macro End_iretwide 0
 iret
 db "End_iretwide1632"
 align wideword_sz,db 'a'
 %endmacro

 %ixdefine push_wideax push eax
 %ixdefine push_widesi push esi

 %ixdefine pop_wideax pop eax
 %ixdefine pop_widesi pop esi

 %ixdefine push_es push es
 %ixdefine pop_es pop es

 %macro jmpfar 2
  jmp %1:%2
 %endmacro


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
%elif _x86_Portable__PLATFORMBITS_==32    ;32 bit x86 Protected Mode code

 %ixdefine _CALL_STACK_ADDR_SZ_ 4

 %ixdefine wideword    dword
 %ixdefine ww          dd
 %ixdefine wideword_SZ 4
 %ixdefine pusha_SZ    wideword_sz*8
 %ixdefine wideword_SZ_nibbles 8
 %ixdefine wideword_bits 32
 %ixdefine wideword_bits_BitRotationMultiply 5
 %ixdefine wideword_bits_mask 11111B
 %ixdefine wideword_SZ_BitRotationMultiply 2
 %ixdefine wideword_MSB 10000000000000000000000000000000b
 %ixdefine wideword_MSN 11110000000000000000000000000000b
 %ixdefine wideword_LSN 00000000000000000000000000001111b

 %ixdefine wideax    eax
 %ixdefine widecx    ecx
 %ixdefine widedx    edx
 %ixdefine widebx    ebx
 %ixdefine widesp    esp
 %ixdefine widebp    ebp
 %ixdefine widesi    esi
 %ixdefine widedi    edi

 %ixdefine _r8       dword[__r8]
 %ixdefine _r9       dword[__r9]
 %ixdefine _r10      dword[__r10]
 %ixdefine _r11      dword[__r11]
 %ixdefine _r12      dword[__r12]
 %ixdefine _r13      dword[__r13]
 %ixdefine _r14      dword[__r14]
 %ixdefine _r15      dword[__r15]

 __r8  dd 0
 __r9  dd 0
 __r10 dd 0
 __r11 dd 0
 __r12 dd 0
 __r13 dd 0
 __r14 dd 0
 __r15 dd 0


 %ixdefine awide
 %ixdefine owide


 %ixdefine pushfwide pushfd
 %ixdefine popfwide  popfd
 %ixdefine cmpswide  cmpsd
 %ixdefine lodswide  lodsd
 %ixdefine stoswide  stosd
 %ixdefine movswide  movsd
 %ixdefine inswide   insd
 %ixdefine outswide  outsd
 %ixdefine retwide   ret
 %macro End_retwide 0
 ret
 db "End_retwide32"
 align wideword_sz,db 'a'
 %endmacro
 %ixdefine iretwide  iretd
 %macro End_iretwide 0
 iretd
 db "End_iretwide32"
 align wideword_sz,db 'a'
 %endmacro

 %ixdefine push_wideax push eax
 %ixdefine push_widesi push esi

 %ixdefine pop_wideax pop eax
 %ixdefine pop_widesi pop esi

 %ixdefine push_es push es
 %ixdefine pop_es pop es

 %macro jmpfar 2
  jmp %1:%2
 %endmacro


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
%elif _x86_Portable__PLATFORMBITS_==64       ;64-bit Long Mode code

 %ixdefine _CALL_STACK_ADDR_SZ_ 8

 %ixdefine wideword    qword
 %ixdefine ww          dq
 %ixdefine wideword_SZ 8
 %ixdefine pusha_SZ    wideword_sz*8
 %ixdefine wideword_SZ_nibbles 16
 %ixdefine wideword_bits 64
 %ixdefine wideword_bits_BitRotationMultiply 6
 %ixdefine wideword_bits_mask 111111B
 %ixdefine wideword_SZ_BitRotationMultiply 3
 %ixdefine wideword_MSB 1000000000000000000000000000000000000000000000000000000000000000b
 %ixdefine wideword_MSN 1111000000000000000000000000000000000000000000000000000000000000b
 %ixdefine wideword_LSN 0000000000000000000000000000000000000000000000000000000000001111b

 %ixdefine wideax    rax
 %ixdefine widecx    rcx
 %ixdefine widedx    rdx
 %ixdefine widebx    rbx
 %ixdefine widesp    rsp
 %ixdefine widebp    rbp
 %ixdefine widesi    rsi
 %ixdefine widedi    rdi

 %ixdefine _r8       r8
 %ixdefine _r9       r9
 %ixdefine _r10      r10
 %ixdefine _r11      r11
 %ixdefine _r12      r12
 %ixdefine _r13      r13
 %ixdefine _r14      r14
 %ixdefine _r15      r15


 %ixdefine awide
 %ixdefine owide


 %ixdefine pushfwide pushfq
 %ixdefine popfwide  popfq
 %ixdefine cmpswide  cmpsq
 %ixdefine lodswide  lodsq
 %ixdefine stoswide  stosq
 %ixdefine movswide  movsq
 %ixdefine inswide   insd
 %ixdefine outswide  outsd
 %ixdefine retwide   ret ;retq
 %macro End_retwide 0
 ret ;retq
 db "End_retwide64"
 align wideword_sz,db 'a'
 %endmacro
 %ixdefine iretwide  iretq
 %macro End_retwide 0
 iretq
 db "End_iretwide64"
 align wideword_sz,db 'a'
 %endmacro

 %ixdefine push_wideax push rax
 %ixdefine push_widesi push rsi

 %ixdefine pop_wideax pop rax
 %ixdefine pop_widesi pop rsi

 %ixdefine push_es 
 %ixdefine pop_es 

 %macro jmpfar 2

 %endmacro



%endif




;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set



%if _x86_Portable__PLATFORMBITS_==16
 ;;
 %ixdefine pushawide pusha
 %ixdefine popawide  popa

%elif _x86_Portable__PLATFORMBITS_==1632
 ;;
 %ixdefine pushawide pushad
 %ixdefine popawide  popad

%elif _x86_Portable__PLATFORMBITS_==32
 ;;
 %ixdefine pushawide pushad
 %ixdefine popawide  popad


%elif _x86_Portable__PLATFORMBITS_==64
 ;;
 %macro pushawide 0
  ;PUSHA
  ;;
   push wideax
   push widecx
   push widedx
   push widebx
   push widesp
   add wideword[widesp],wideword_sz*5
   push widebp
   push widesi
   push widedi
 %endmacro



 %macro popawide 0
  ;POPA
  ;;
   pop widedi
   pop widesi
   pop widebp
   ;pop widesp
   add widesp,wideword_sz
   pop widebx
   pop widedx
   pop widecx
   pop wideax
 %endmacro




%endif






;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set





%if _x86_Portable__LEVEL_==0  ;If privileged code, generate privileged instructions
 %ixdefine cliwide cli
 %ixdefine stiwide sti
 %ixdefine widecli cli
 %ixdefine widesti sti
%elif _x86_Portable__LEVEL_==1 ;If user code, don't generate those instructions
 %ixdefine cliwide
 %ixdefine stiwide
 %ixdefine widecli
 %ixdefine widesti
%endif


align 16
x86_Portable_END:




;EOF